import java.util.Vector;

public class DirData implements Cloneable{
	String dir;
	String shortName;
	String colorName;
	ResultData prog;
	Vector pastdata;
	
	public DirData(){}
	public DirData(String _shortName, String _dir){
		dir = _dir;
		shortName = _shortName;
		colorName = "Yellow";// default
		pastdata = new Vector();
	}
	public DirData(String _shortName, String _colorName, String _dir){
		dir = _dir;
		shortName = _shortName;
		colorName  = _colorName;
		pastdata = new Vector();
	}
	public boolean hasSameDir(DirData dt){
		return(dir.equals(dt.getDir()));
	}
	public void setDir(String _dir){ dir = _dir;}
	public void setShortName(String _sname){shortName = _sname;}
	public void setProg(ResultData _prog){prog = _prog;}
	public String getDir(){return dir;}
	public String getShortName(){return shortName;}
	public ResultData getProg(){return prog;}
	public Object clone(){
		DirData ndata = new DirData(shortName,colorName,dir);
		ndata.setProg(prog);
		return ndata;	
	}
	public void informChange(){
		if(prog != null){
			prog.setDirName(dir);
			prog.setShortName(shortName);
			prog.setColorName(colorName);
		}
	}
	public void setColorName(String str){
//System.out.println("cahnge "+str);
		colorName = str;
		setColor();
	}
	public String getColorName(){return colorName;}
	public void clearPastData(){pastdata.removeAllElements();}
	public void addPastData(ResultData rd){
		pastdata.addElement(rd);
	}
	private void setColor(){
		for(int i = 0;i<pastdata.size();i++){
			ResultData rd = (ResultData)(pastdata.elementAt(i));
			rd.setColorName(colorName);
		}
	}
}// end of class DirData